/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sync4j.syncclient.spds;

import java.util.Hashtable;

/**
 * This is a factory for SyncManager objects. It istantiates and configures
 * a new SyncManager with the information provided in the given properties.
 *
 * @author Fabio Maggi @ Funambol
 * @version  $Id:
 */
public class SyncManagerFactory {

    //---------------------------------------------------------------- Constants

    //---------------------------------------------------------------- Private data

    //---------------------------------------------------------------- Costructors

    //---------------------------------------------------------------- Public methods

    /**
     * Returns a new instance of the SyncManager for the given data store
     * and configured with the given properties.
     *
     * @param dataStoreName the data store name
     * @param properties the configuration properties
     *
     * @return a new instance of the SyncManager for the given data store
     *         and configured with the given properties
     */
    public static SyncManager getSyncManager(String dataStoreName,
                                             String sourceType,
                                             String sourceName,
                                             Hashtable properties)
    throws SyncException {

        SyncManager syncManager = new SyncManager(dataStoreName,
                                                  sourceType,
                                                  sourceName,
                                                  properties);

        return syncManager;
    }

    // -------------------------------------------------------------- Private methods

}